<?xml version = "1.0"?>

<!-- Fig. 12.26 : axes.xsl     -->
<!-- XSLT document using XPath -->

<xsl:stylesheet version = "1.0" 
         xmlns:xsl = "http://www.w3.org/1999/XSL/Transform">

   <xsl:template match = "/product">

      <html>

         <head>
            <title>Axes example</title>

            <style type = "text/css">
               .node { font-family: monospace;
                       font-weight: bold; }
            </style>
         </head>

         <body>
            Decendents of 

            <span class = "node">completeTrainingCourse</span> are: 

            <xsl:apply-templates select = 
               "completeTrainingCourses//node()"/>
            <br /><br />

               Self for 
               <span class = "node">webBasedTraining</span> is

               <xsl:apply-templates 
                  select = "webBasedTraining"/>
               <br /><br />

               Parent of 
               <strong>C How to Program</strong> is

               <em>
                  <!-- returns the name of the parent element -->
                  <xsl:value-of select = 
                  "name(//parent::node()[. = 'C How to Program'])"/>
               </em>

               <br /><br />

               Child of 
               <span class = "node">title</span>
               element for the second

               <span class = "node">completeTrainingCourse</span> is 

               <em>
                  <xsl:value-of select = 
                  "//child::completeTrainingCourse[ 2 ]/title"/>
               </em>

               <br /><br />

               Is <span class = "node">product</span>

               the ancestor of
               <span class = "node">XML How to Program</span>?

               <xsl:if test = "name(//node()[. = 
               'XML How to Program']/ancestor::product) = 'product'">
                  <em>Yes</em>
               </xsl:if>

               <br /><br />

               First <span class = "node">subject</span> preceding
               
               <strong>
                  Programming COM+ with Visual Basic
               </strong> is 

               <em>
                 <xsl:value-of select = 
                 "//subject[. = 'Programming COM+ with Visual Basic'
                  ]/preceding-sibling::subject[ 1 ]"/>
              </em> 

              <br /><br />

              First <span class = "node">subject</span> following

              <strong>
                 Introduction to Java programming
              </strong> is 

              <em>
                 <xsl:value-of select = 
                  "//subject[. = 'Introduction to Java programming'
                  ]/following-sibling::subject[ 1 ]"/>
              </em>

         </body>

      </html>

   </xsl:template>
    
   <xsl:template match = "completeTrainingCourse">
      <br /><br />
      <em><xsl:value-of select = "title"/></em>
      <li><em><xsl:value-of select = "book"/></em></li>
      <li><em><xsl:value-of select = "cd"/></em></li>
   </xsl:template>

   <xsl:template match = "webBasedTraining">
      <em><xsl:value-of select = "subject"/></em>
   </xsl:template>

   <xsl:template match = "* | text()"/>

</xsl:stylesheet>
